# Author: Dennis Wu
# Date: May 29, 2005
# Desciption: Reads and rewrites BLIF files using SIS.

set blifFiles [glob *.blif]
set blifFiles [lsort -ascii $blifFiles]
set fPreProcess [open sistouch.script w]

puts "sismap..."
foreach blifFile $blifFiles {
    puts $fPreProcess "echo \"File = $blifFile\""
    puts $fPreProcess "read_blif $blifFile"
    puts $fPreProcess "write_blif $blifFile"
}
puts $fPreProcess "quit"

close $fPreProcess

catch {exec {sis} {-sx} {-f} sistouch.script}

puts "done!"
