# Author: Dennis Wu
# Date: June 2, 2005
# Desciption: Reads sis output and tabulates runtime information in runtime.csv.
set fIn [open "sisrun.out" r]
set fOut [open "runtime.csv" w]

puts "getting sis runtimes..."

puts $fOut [format "%20s %10s" "Filename" "time"]

while { [gets $fIn inLine] >=0 } {
    set ext [string range $inLine end-5 end]
    if {[string compare $ext {.blif }] == 0} {
	set circuit $inLine
	while { [gets $fIn inLine] >=0 } {
	    # find elapse:
	    set prefix [string range $inLine 0 6]
	    if {[string compare $prefix "elapse:"] == 0} {
		scan $inLine {%s %f} junk seconds
		set milli [expr $seconds * 1000]
		puts $fOut [format "%20s %10s" $circuit $milli]
		break;
	    }
	}
    }
}

close $fOut
close $fIn

