# Author: Dennis Wu
# Date: April 10, 2005
# Description: Merges table results.csv with area information in praetor.csv
# and sismap.csv.  Merged table written to results.csv.

set fPraetor [open "praetor.csv" r]
set fSismap [open "sismap.csv" r]

exec {mv} {results.csv} {resultsold.csv}
set fResultsOld [open "resultsold.csv" r]
set fResults [open "results.csv" w]

# output field headings
gets $fResultsOld lineResultsOld
gets $fPraetor linePraetor   
gets $fSismap lineSismap
puts $fResults [format "%s %10s %10s" $lineResultsOld {praetor} {sismap}]

# output data
while { [gets $fResultsOld lineResultsOld] >=0 } {
    gets $fPraetor linePraetor   
    gets $fSismap lineSismap
    scan $linePraetor {%s %d} j1 praetor
    scan $lineSismap {%s %d} j2 sismap
    puts $fResults [format "%s %10d %10d" $lineResultsOld $praetor $sismap]
}

close $fResults
close $fPraetor
close $fSismap
close $fResultsOld
